#include <XRS/Socket.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>

#ifdef NEWS_OS
extern "C" int socket(int,int,int);
extern "C" int bind(int,struct sockaddr_un*,int);
extern "C" int listen(int,int);
extern "C" int accept(int,struct sockaddr_un*,int*);
extern "C" int connect(int,struct sockaddr_un*,int);
#endif
extern "C" void unlink(char*);

Socket::Socket(char *ss):ns(0){
   strcpy(address,ss);
   unlink(address);
   saun.sun_family=AF_UNIX;
   strcpy(saun.sun_path,address);
   len=sizeof(saun.sun_family)+strlen(saun.sun_path);
   if((s=socket(AF_UNIX,SOCK_STREAM,0))<0)
      { perror("server: can't make a socket."); exit(1);}
   if(bind(s,&saun,len)<0)
      { perror("server: can't bind.");   exit(1);}
   if(listen(s,5)<0)
      { perror("server: can't listen."); exit(1);}
}
   
Socket::~Socket(){ if(ns) close();  ::close(s);  unlink(address);}

int Socket::open(){
   if((ns=accept(s,&saun,&fromlen))<0)
     { perror("server: can't accept clients."); exit(1);}
   return ns;
}


ClientSocket::ClientSocket(char *address){
   saun.sun_family=AF_UNIX;
   strcpy(saun.sun_path,address);
   len=sizeof(saun.sun_family)+strlen(saun.sun_path);
   if((s=socket(AF_UNIX,SOCK_STREAM,0))<0){
      fprintf(stderr,"client: can't make a socket of \"%s\".\n",address);
      exit(1);
   }
   if(connect(s,&saun,len)<0){
      fprintf(stderr,
              "client: can't connect the server through \"%s\".\n",address); 
      exit(1); 
   }
};




